package org.apache.fulcrum.security.torque.om;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Tue May 23 08:21:47 CEST 2017]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TorqueTurbineUserGroupRole
 */
public abstract class BaseTorqueTurbineUserGroupRole 
    implements Persistent, Serializable
{
    /** Serial version */
    private static final long serialVersionUID = 1495520507385L;



    /** Defines the userId field. */
    private Integer userId = null;

    /** Defines the groupId field. */
    private Integer groupId = null;

    /** Defines the roleId field. */
    private Integer roleId = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aTorqueTurbineUser field. */
    private TorqueTurbineUser aTorqueTurbineUser = null;

    /** Defines the aTorqueTurbineGroup field. */
    private TorqueTurbineGroup aTorqueTurbineGroup = null;

    /** Defines the aTorqueTurbineRole field. */
    private TorqueTurbineRole aTorqueTurbineRole = null;





    /**
     * Get the value of userId.
     *
     * @return Integer
     */
    public Integer getUserId() 
    {
        
        return userId;
    }

    /**
     * Set the value of userId.
     *
     * @param v new value
     */
    public void setUserId(Integer v)
    {
        if (!ObjectUtils.equals(this.userId, v))
        {
            setModified(true);
        }

        this.userId = v;
        if (aTorqueTurbineUser != null && !ObjectUtils.equals(aTorqueTurbineUser.getEntityId(), v))
        {
            aTorqueTurbineUser = null;
        }


    }
    
    /**
     * Get the value of groupId.
     *
     * @return Integer
     */
    public Integer getGroupId() 
    {
        
        return groupId;
    }

    /**
     * Set the value of groupId.
     *
     * @param v new value
     */
    public void setGroupId(Integer v)
    {
        if (!ObjectUtils.equals(this.groupId, v))
        {
            setModified(true);
        }

        this.groupId = v;
        if (aTorqueTurbineGroup != null && !ObjectUtils.equals(aTorqueTurbineGroup.getEntityId(), v))
        {
            aTorqueTurbineGroup = null;
        }


    }
    
    /**
     * Get the value of roleId.
     *
     * @return Integer
     */
    public Integer getRoleId() 
    {
        
        return roleId;
    }

    /**
     * Set the value of roleId.
     *
     * @param v new value
     */
    public void setRoleId(Integer v)
    {
        if (!ObjectUtils.equals(this.roleId, v))
        {
            setModified(true);
        }

        this.roleId = v;
        if (aTorqueTurbineRole != null && !ObjectUtils.equals(aTorqueTurbineRole.getEntityId(), v))
        {
            aTorqueTurbineRole = null;
        }


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated TorqueTurbineUser object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated TorqueTurbineUser object
     * @throws TorqueException when reading from the database fails.
     */
    public TorqueTurbineUser getTorqueTurbineUser()
        throws TorqueException
    {
        if (aTorqueTurbineUser == null && !org.apache.commons.lang.ObjectUtils.equals(this.userId, null))
        {
            aTorqueTurbineUser = org.apache.fulcrum.security.torque.om.TorqueTurbineUserPeer.retrieveByPK(SimpleKey.keyFor(this.userId));
        }
        return aTorqueTurbineUser;
    }

    /**
     * Return the associated TorqueTurbineUser object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated TorqueTurbineUser object
     * @throws TorqueException
     */
    public TorqueTurbineUser getTorqueTurbineUser(Connection connection)
        throws TorqueException
    {
        if (aTorqueTurbineUser == null && !org.apache.commons.lang.ObjectUtils.equals(this.userId, null))
        {
            aTorqueTurbineUser = org.apache.fulcrum.security.torque.om.TorqueTurbineUserPeer.retrieveByPK(SimpleKey.keyFor(this.userId), connection);
        }
        return aTorqueTurbineUser;
    }


    /**
     * Declares an association between this object and a TorqueTurbineUser object
     *
     * @param v TorqueTurbineUser
     */
    public void setTorqueTurbineUser(TorqueTurbineUser v)
    {
        if (v == null)
        {
            setUserId(null);
        }
        else
        {
            setUserId(v.getEntityId());
        }
        aTorqueTurbineUser = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setTorqueTurbineUserKey(ObjectKey key) throws TorqueException
    {
       
        setUserId(Integer.valueOf(((NumberKey) key).intValue()));
     }

    /**
     * Returns the associated TorqueTurbineGroup object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated TorqueTurbineGroup object
     * @throws TorqueException when reading from the database fails.
     */
    public TorqueTurbineGroup getTorqueTurbineGroup()
        throws TorqueException
    {
        if (aTorqueTurbineGroup == null && !org.apache.commons.lang.ObjectUtils.equals(this.groupId, null))
        {
            aTorqueTurbineGroup = org.apache.fulcrum.security.torque.om.TorqueTurbineGroupPeer.retrieveByPK(SimpleKey.keyFor(this.groupId));
        }
        return aTorqueTurbineGroup;
    }

    /**
     * Return the associated TorqueTurbineGroup object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated TorqueTurbineGroup object
     * @throws TorqueException
     */
    public TorqueTurbineGroup getTorqueTurbineGroup(Connection connection)
        throws TorqueException
    {
        if (aTorqueTurbineGroup == null && !org.apache.commons.lang.ObjectUtils.equals(this.groupId, null))
        {
            aTorqueTurbineGroup = org.apache.fulcrum.security.torque.om.TorqueTurbineGroupPeer.retrieveByPK(SimpleKey.keyFor(this.groupId), connection);
        }
        return aTorqueTurbineGroup;
    }


    /**
     * Declares an association between this object and a TorqueTurbineGroup object
     *
     * @param v TorqueTurbineGroup
     */
    public void setTorqueTurbineGroup(TorqueTurbineGroup v)
    {
        if (v == null)
        {
            setGroupId(null);
        }
        else
        {
            setGroupId(v.getEntityId());
        }
        aTorqueTurbineGroup = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setTorqueTurbineGroupKey(ObjectKey key) throws TorqueException
    {
       
        setGroupId(Integer.valueOf(((NumberKey) key).intValue()));
     }

    /**
     * Returns the associated TorqueTurbineRole object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated TorqueTurbineRole object
     * @throws TorqueException when reading from the database fails.
     */
    public TorqueTurbineRole getTorqueTurbineRole()
        throws TorqueException
    {
        if (aTorqueTurbineRole == null && !org.apache.commons.lang.ObjectUtils.equals(this.roleId, null))
        {
            aTorqueTurbineRole = org.apache.fulcrum.security.torque.om.TorqueTurbineRolePeer.retrieveByPK(SimpleKey.keyFor(this.roleId));
        }
        return aTorqueTurbineRole;
    }

    /**
     * Return the associated TorqueTurbineRole object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated TorqueTurbineRole object
     * @throws TorqueException
     */
    public TorqueTurbineRole getTorqueTurbineRole(Connection connection)
        throws TorqueException
    {
        if (aTorqueTurbineRole == null && !org.apache.commons.lang.ObjectUtils.equals(this.roleId, null))
        {
            aTorqueTurbineRole = org.apache.fulcrum.security.torque.om.TorqueTurbineRolePeer.retrieveByPK(SimpleKey.keyFor(this.roleId), connection);
        }
        return aTorqueTurbineRole;
    }


    /**
     * Declares an association between this object and a TorqueTurbineRole object
     *
     * @param v TorqueTurbineRole
     */
    public void setTorqueTurbineRole(TorqueTurbineRole v)
    {
        if (v == null)
        {
            setRoleId(null);
        }
        else
        {
            setRoleId(v.getEntityId());
        }
        aTorqueTurbineRole = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setTorqueTurbineRoleKey(ObjectKey key) throws TorqueException
    {
       
        setRoleId(Integer.valueOf(((NumberKey) key).intValue()));
     }







    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(TorqueTurbineUserGroupRolePeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    TorqueTurbineUserGroupRolePeer.doInsert((TorqueTurbineUserGroupRole) this, con);
                    setNew(false);
                }
                else
                {
                    TorqueTurbineUserGroupRolePeer.doUpdate((TorqueTurbineUserGroupRole) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }





    private final SimpleKey[] pks = new SimpleKey[3];
    private final ComboKey comboPK = new ComboKey(pks);

    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
        setUserId(((NumberKey) keys[0]).intValue());
        setGroupId(((NumberKey) keys[1]).intValue());
        setRoleId(((NumberKey) keys[2]).intValue());
    }

    /**
     * Set the PrimaryKey using SimpleKeys.
     *
     * @param Integer userId
     * @param Integer groupId
     * @param Integer roleId
     */
    public void setPrimaryKey(Integer userId, Integer groupId, Integer roleId)
        
    {
        setUserId(userId);
        setGroupId(groupId);
        setRoleId(roleId);
    }

    /**
     * Set the PrimaryKey using a String.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        setPrimaryKey(new ComboKey(key));
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        SimpleKey[] pks = new SimpleKey[3];
        pks[0] = SimpleKey.keyFor(getUserId());
        pks[1] = SimpleKey.keyFor(getGroupId());
        pks[2] = SimpleKey.keyFor(getRoleId());
        return new ComboKey(pks);
    }


    /**
     * Returns an id that differentiates the referenced TorqueTurbineUser object
     * from all other TorqueTurbineUser objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForTorqueTurbineUser()
    {
        return SimpleKey.keyFor(getUserId());
    }
    /**
     * Returns an id that differentiates the referenced TorqueTurbineGroup object
     * from all other TorqueTurbineGroup objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForTorqueTurbineGroup()
    {
        return SimpleKey.keyFor(getGroupId());
    }
    /**
     * Returns an id that differentiates the referenced TorqueTurbineRole object
     * from all other TorqueTurbineRole objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForTorqueTurbineRole()
    {
        return SimpleKey.keyFor(getRoleId());
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public TorqueTurbineUserGroupRole copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public TorqueTurbineUserGroupRole copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public TorqueTurbineUserGroupRole copy(boolean deepcopy) throws TorqueException
    {
        TorqueTurbineUserGroupRole torqueTurbineUserGroupRole = new TorqueTurbineUserGroupRole();

        return copyInto(torqueTurbineUserGroupRole, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public TorqueTurbineUserGroupRole copy(boolean deepcopy, Connection con) throws TorqueException
    {
        TorqueTurbineUserGroupRole torqueTurbineUserGroupRole = new TorqueTurbineUserGroupRole();

        return copyInto(torqueTurbineUserGroupRole, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    public TorqueTurbineUserGroupRole copyInto(TorqueTurbineUserGroupRole copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    public TorqueTurbineUserGroupRole copyInto(TorqueTurbineUserGroupRole copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected TorqueTurbineUserGroupRole copyInto(TorqueTurbineUserGroupRole copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setUserId((Integer) null);
        copyObj.setGroupId((Integer) null);
        copyObj.setRoleId((Integer) null);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    public TorqueTurbineUserGroupRole copyInto(TorqueTurbineUserGroupRole copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setUserId((Integer) null);
        copyObj.setGroupId((Integer) null);
        copyObj.setRoleId((Integer) null);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.fulcrum.security.torque.om.TorqueTurbineUserGroupRolePeer peer
            = new org.apache.fulcrum.security.torque.om.TorqueTurbineUserGroupRolePeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.fulcrum.security.torque.om.TorqueTurbineUserGroupRolePeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.fulcrum.security.torque.om.TorqueTurbineUserGroupRolePeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("TorqueTurbineUserGroupRole:\n");
        str.append("userId = ")
           .append(getUserId())
           .append("\n");
        str.append("groupId = ")
           .append(getGroupId())
           .append("\n");
        str.append("roleId = ")
           .append(getRoleId())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        TorqueTurbineUserGroupRole other = (TorqueTurbineUserGroupRole) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }



    /**
     * Compares the content of this object to another object
     *
     * @param toCompare The object to compare to.
     * @return true if all of the columns in the other object have 
     *         the same value as the objects in this class.
     */
    public boolean valueEquals(TorqueTurbineUserGroupRole toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!ObjectUtils.equals(this.userId, toCompare.getUserId()))
        {
            return false;
        }
        if (!ObjectUtils.equals(this.groupId, toCompare.getGroupId()))
        {
            return false;
        }
        if (!ObjectUtils.equals(this.roleId, toCompare.getRoleId()))
        {
            return false;
        }
        return true;
    }



}
